<!--  
 * This file is part of the SecureFlag Platform.
 * Copyright (c) 2020 SecureFlag Limited.
 * 
 * This program is free software: you can redistribute it and/or modify  
 * it under the terms of the GNU General Public License as published by  
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 -->
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="description" content="SecureFlag">
<title>SecureFlag - Exercise</title>
<link rel="icon" type="image/png" sizes="96x96"
	href="/assets/img/favicon-96x96.png">
<link href="/assets/css/lib.css" rel="stylesheet">
<link href="/assets/css/style.css" rel="stylesheet">
<link href="/assets/css/exercise.css" rel="stylesheet">
</head>
<body>
	<div ng-app="sfNg">
		<div class="ng-cloak" id="exercise" ng-controller="exercise">
			<nav id="topnavbar"
				class="navbar navbar-default navbar-fixed-top height35 borderBottom2 sfNavbarN">
				<div id="navContainer" class="container flexVC">
					<div class="navbar-header marginRight5 minWidth170">
						<img src="/assets/img/sfhne.png" class="sfLogoExercise inlineBlock" /><span class="sfcee">CE</span>
					</div>

					<div id="navbar" class="height35">
						<ul class="nav navbar-nav exerciseNavbar height35 ">

							<li
								class=" navbarE ng-cloak pointer exerciseSetupDiv learnWizard"
								ng-click="navigateToStart()" ng-class="getStartPanelClass()">
								<div class="synDivNavE" ng-class="getDivNavClass()" ng-class="{'activePanel' : startOpen}">
									<div ng-show="getStartPanelClass() == 'headVulnerable'" class="exclamation">&nbsp;!&nbsp;</div>
									<img src="/assets/img/start.svg" class="flIcon startIcon" />
									<div class="liTitle liTitleStart ">Setup</div>
									<div class="navDetails marginTop7">Setup the Exercise</div>
								</div>
							</li>

							<li class="navbarE ng-cloak pointer  flagWizard "
								ng-click="navigateToFlag(flag)"
								ng-class="getPanelStatusClass(flag,$last)"
								ng-repeat="flag in exerciseDetails.flags | orderBy: '-flagList[0].optional'">
								<div class="synDivNavE" ng-class="getActivePanelClass(flag)">
									<div ng-show="getPanelStatusClass(flag,null).indexOf('headVulnerable')>=0" class="exclamation">&nbsp;!&nbsp;</div>
									<img ng-show="flag.flagList[0].type == 'REMEDIATION'"
										class="flIcon hackFixIcon" src="/assets/img/remediate1.svg"><img
										ng-show="flag.flagList[0].type == 'EXPLOITATION'"
										class="flIcon hackFixIcon" src="/assets/img/exploit.svg">
									<div ng-show="flag.flagList[0].type == 'EXPLOITATION'"
										class="liTitle ">Hack</div>
									<div ng-show="flag.flagList[0].type == 'REMEDIATION'"
										class="liTitle ">Fix</div>
									<div ng-class="getIsLockedClass(flag.flagList[0].type)" class="navDetails marginTopM2">{{flag.title}}</div>
								</div>
							</li>




							<li class="font13 ng-cloak" id="tournamentDropdown"
								ng-class="isChallenge == true ? '' : 'visibilityHidden'"><a
								ng-click="navigateToTournament()"
								ng-class="{'tournamentOpen' : showTournament}"
								title="tournament" id="challengeAnchor"
								class="dropdown-toggle white ">Tournament<span class="caret"></span>
							</a>
								<ul class="paddingTop0" ng-show="showTournament"
									id="tournamentUL">
									<li>
										<div class="container">
											<div class="row">
												<div class="col-md-12 center ">
													<div class="row center">
														<h4 class="center sfblue">Tournament Table</h4>
														<div class="exerciseTableFilter">
															<p class="inlineBlock">Search:</p>
															<input placeholder="Type to filter..." autocomplete="off"
																ng-change="updateTableFilteredList()"
																ng-model="tableQuery" class="queryInput">
														</div>
														<table id="tournamentTableUsers"
															class="table  table-hover left tournamentTable marginBottom0 font12"
															at-table at-list="challengeDetailsTableFilteredList"
															at-paginated at-config="challengeUserTableConfig">
															<thead>

															</thead>
															<tbody>
																<tr ng-class="highlightIfTableUser(item.user)">
																	<td at-title="#">{{(challengeUserTableConfig.currentPage
																		* 10)+($index+1)}}</td>
																	<td at-attribute="user" at-title="User">{{item.user}}</td>
																	<td class="center" at-initial-sorting="desc"
																		at-attribute="challengeScore" at-title="Score">{{item.challengeScore}}</td>
																	<td class="center" at-attribute="challengeRunExercises"
																		at-title="Run Exercises">{{(item.challengeRunExercises)}}</td>
																	<!--  <td at-attribute="team.name" at-title="Team">{{item.team.name}}</td>-->
																	<td at-attribute="country.name" at-title="Country">{{item.country.name}}</td>


																</tr>
															</tbody>
														</table>
														<at-pagination at-list="challengeDetailsTableFilteredList"
															at-config="challengeUserTableConfig"></at-pagination>
														<p class="marginTop0 marginBottom20">
															<small>Refreshed at
																{{getDateInCurrentTimezone(challengeDetails.lastRefreshed,'HH:mm
																(Z) on MMM D YYYY')}}</small> <i
																ng-class="{'opacity02' : refreshing }" title="Refresh"
																ng-click="refreshChallengeResults()"
																class="fa fa-history pointer marginLeft5"></i>
														</p>
													</div>
												</div>
											</div>
											<div class="row">
												<div class="col-md-12 center paddingLeft0">
													<div class="row center">
														<h4 class="center sfblue margimBottom0">Tournament
															Results</h4>

														<div>
															<div class="left">
																<p class="inlineBlock">Search:</p>
																<input placeholder="Type to filter..."
																	autocomplete="off"
																	ng-change="updateTableFilteredList()"
																	ng-model="tableQuery" class="queryInput">
															</div>
															<div class="scrollx">
																<table class="table table-hover font12"
																	id="challengeResultsHeader">
																	<thead>
																		<tr>
																			<th class="width185 allCaps"><strong>User</strong></th>
																			<th class="width185 centered"
																				ng-repeat="t in challengeDetails.theads | orderBy: 'id'">{{t.ename}}</th>
																		</tr>
																	</thead>
																</table>

																<table class="table table-hover font12" at-table
																	at-paginated
																	at-list="challengeDetailsTableFilteredList"
																	at-config="challengeUserTableConfig"
																	id="challengeResults">
																	<thead>

																	</thead>
																	<tbody>

																		<tr ng-class="highlightIfUser(item.user)">
																			<td class="width185" at-attribute="{{item.user}}"
																				at-title="">{{item.user}}</td>

																			<td class="centered width185"
																				at-attribute="{{f.name}}" at-title="{{f.name}}"
																				ng-class="getClassForChallengeResult(item.user,f.id)"
																				ng-repeat="f in challengeDetails.theads | orderBy: 'id'">
																				<span>{{getChallengeResultFor(item.user,f.id)}}</span>
																				<span
																				ng-show="isPlacedInChallenge(item.user,f.id)"
																				ng-class="getClassPlacementInChallenge(item.user,f.id)"
																				class="badge">{{getPlacementInChallenge(item.user,f.id)}}</span>
																			</td>
																		</tr>
																	</tbody>

																</table>
															</div>
															<div class="center">
																<at-pagination
																	at-list="challengeDetailsTableFilteredList"
																	at-config="challengeUserTableConfig"></at-pagination>
															</div>
														</div>

														<p class="center">
															<small>Refreshed at
																{{getDateInCurrentTimezone(challengeDetails.lastRefreshed,'HH:mm
																(Z) on MMM D YYYY')}}</small><i
																ng-class="{'opacity02' : refreshing }" title="Refresh"
																ng-click="refreshChallengeResults()"
																class="fa fa-history pointer marginLeft5"></i>
														</p>
													</div>
												</div>
											</div>
										</div>
									</li>
								</ul></li>
							<li id="eName"><div class="exerciseTitleDiv ellipsis">{{exerciseName}} <small
								class="exerciseTechSmall">{{exerciseDetails.technology}}</small></div></li>

						</ul>


						<input id="synInp" />
						<div class="exerciseButtons ng-cloak">
							<div id="cdownDiv">
								<a><i class="fa opacity09 fa-clock-o"></i><span class="badge"
									id="cdown">{{countdown}}</span></a>
							</div>
							<a ng-show="!is_chrome && !is_newedge"
								class="ng-cloak showHelp toolbarFont"
								ng-click="toggleClipboardPanel()" title="Clipboard menu" href=""><i
								class="fa fa-clipboard font14"></i></a> <a
								ng-class="{'marginLeft14' : !is_chrome && !is_newedge}"
								class=" showHelp toolbarFont" ng-click="navigateToLearn()"
								title="Learn about {{exerciseKbs[0].vulnerability}}" href=""><i
								class="fa fa-graduation-cap font14 "></i></a> <a
								class="marginLeft14 toolbarFont showHelp"
								ng-click="showExerciseStatusModal()" title="Stop Exercise"
								href=""><i class="fa fa-power-off font14 marginRight5"></i></a>


						</div>
					</div>

				</div>

				<div id="miniFlagPanel" class="flip-card ng-cloak"
					ng-class="{'minimize': isMinimized}" ng-show="miniFlagOpen">
					<div class="flip-card-inner"
						ng-class="{'flip-card-flipped':isFlipped}">
						<div class="flagAreaPanel col-md-12 flip-card-front"
							ng-show="!isFlipped">
							<h4 class="inlineBlock">{{tmpPanelFlag.title}}</h4>
							<div class="flagPanelScore center inlineBlock ng-cloak">
								<a title="Check Results" class="sfblue ng-cloak"
									ng-show="tmpPanelFlag.flagList[0].selfCheckAvailable && !isSolved(tmpPanelFlag.flagList[0])"
									ng-click="flipCheck(tmpPanelFlag.flagList[0].selfCheck.name)"
									href=""><i class="fa fa-check-square-o font18"></i></a> <a
									ng-show="tmpPanelFlag.flagList[0].hintAvailable && !isSolved(tmpPanelFlag.flagList[0])"
									title="Take a Hint" class="sfblue ng-cloak"
									ng-click="getHintModal(tmpPanelFlag.flagList[0].id,undefined,tmpPanelFlag.flagList[0].hint.scoreReducePercentage,true)"
									href=""><i class="fa fa-question font18"></i></a> <a
									title="Restore Window" class="sfblue"
									ng-click="unMinimizeMiniFlag(tmpPanelFlag)" href=""><i
									class="fa fa-window-restore font18 marginTop5"></i></a> <a
									ng-click="closeMiniFlag()" title="Close"
									class="sfblue ng-cloak marginRight5" href=""><i
									class="fa fa-window-close-o font18"></i></a>
							</div>
							<div id="instructionsMarkdownMini-md"></div>
						</div>



						<div ng-show="isFlipped"
							class="col-md-5 flip-card-back paddingLeft0 paddingRight0">

							<div class="col-md-2 checksButtonMini">
								<div class="left">
									<a ng-click="closeMiniFlag()" title="Close"
										class="p14 sfblue marginLeft10" href=""><i
										class="fa fa-times"></i></a> <a title="Flip"
										class="marginLeft10 sfblue p14" ng-click="flipBack()" href=""><i
										class="fa fa-step-backward"></i></a>
								</div>
								<div class="marginTop20">
									<div ng-show="tmpPanelFlag.flagList[0].selfCheckAvailable">
										<i class="fa fa-check-square-o p28"></i> <br /> <a
											ng-show="tmpPanelFlag.flagList[0].selfCheckAvailable"
											class="btn btn-primary sf-button btn-xs outline p11"
											ng-click="refreshResults(tmpPanelFlag.flagList[0].selfCheck.name)"
											href="">{{tmpPanelFlag.flagList[0].selfCheckStatus==undefined
											&& "Check Results" || "Refresh Results"}}</a>
									</div>
									<div ng-show="tmpPanelFlag.flagList[0].hintAvailable">
										<i class="fa fa-question p28 marginTop10"></i> <br /> <a
											ng-show="tmpPanelFlag.flagList[0].hintAvailable"
											class="btn btn-primary sf-button btn-xs outline p11"
											ng-click="getHintModal(tmpPanelFlag.flagList[0].id,undefined,tmpPanelFlag.flagList[0].hint.scoreReducePercentage,true)"
											href="">Take a Hint</a>
									</div>
								</div>
							</div>
							<div class="col-md-10 paddingRight0 paddingLeft0">

								<div class="fakeScreen fakeScreenMini">
									<p class="line1 marginTop0 marginBottom0">$
										./secureflag-bot</p>
									<p class="line2 marginTop0 marginBottom0">
										{{terminalMessage}}&nbsp;<span class="cursor4">_</span>
									</p>
									<p ng-show="tmpPanelFlag.flagList[0].optional && isHintDisplayed()" class="line2 marginTop0 marginBottom0">
										 This is an optional, click on "Next" to skip without losing points.
									</p>
									<div id="selfCheckMarkdownMini-md"></div>
									<div id="hintMarkdownMini-md"></div>
								</div>
							</div>
						</div>
					</div>
				</div>

				<div id="clipboardPanel" ng-show="clipboardPanelOpen"
					class="ng-cloak">
					<a href="" ng-click="closeClipboardPanel()" title="Close"
						class="floatRight marginRight5">X</a>
					<p id="clipboardText" class="lead">Changes to the text below
						will affect the clipboard of your exercise.</p>

					<textarea id="clipboardTextarea" ng-model="clipboardArea"
						class="fInput" rows="10"></textarea>
					<a href="" title="Close" ng-click="closeClipboardPanel()">Close</a>
				</div>

			</nav>
			<div id="flagPanel" ng-class="getFlagPenlSizeAndOrientation()"
				ng-show="tmpPanelFlagOpen" class="ng-cloak">

				<div class="flagAreaPanel col-md-12 ng-cloak">
					<div class="upper">
						<div class="row ng-cloak">
							<div class="col-md-4 ng-cloak">
								<img ng-show="tmpPanelFlag.flagList[0].type == 'REMEDIATION'"
									class="flIcon hackFixIcon hackIconFlag ng-cloak"
									src="/assets/img/remediate1.svg"><img
									ng-show="tmpPanelFlag.flagList[0].type == 'EXPLOITATION'"
									class="flIcon hackFixIcon hackIconFlag ng-cloak"
									src="/assets/img/exploit.svg">
								<div ng-show="tmpPanelFlag.flagList[0].type == 'EXPLOITATION'"
									class="liTitle ng-cloak">
									<h4>Hack</h4>
								</div>
								<div ng-show="tmpPanelFlag.flagList[0].type == 'REMEDIATION'"
									class="liTitle ng-cloak">
									<h4>Fix</h4>
								</div>
							</div>
							<div class="col-md-2 pointsColumn center">
								<div ng-show="!tmpPanelFlag.flagList[0].optional"
									class="ng-cloak flagPanelScore center inlineBlock">
									<div class="marginRight15 ng-cloak"
										ng-show="!tmpPanelFlag.flagList[0].optional">
										<svg class="scoreSvgExercise" width="40" height="40">
  <circle cx="20" cy="20" r="14"
												fill="{{getColorForScore(tmpPanelFlag.flagList[0].maxScore)}}" />
  <text x="50%" y="50%" text-anchor="middle" fill="white"
												font-family="monospace" font-size="15px" dy=".3em">{{tmpPanelFlag.flagList[0].maxScore}}</text>
</svg>
										<p class="scoreTextExercise" class="">points</p>
									</div>
								</div>
							</div>
							<div class="col-md-2 trophyColumn center">
								<div class="ng-cloak" ng-show="!tmpPanelFlag.flagList[0].optional">
									<img class="exerciseTrophy" src="/assets/img/trophy.svg">
									<p class="card-text ellipsis trophyText">
										<small class="text-muted">{{exerciseDetails.trophyName}}</small>
									</p>
								</div>
							</div>
							<div class="col-md-4">
								<div class="floatRight marginTopM5 menuOpacity">
									<a ng-show="!alignLeft" ng-click="leftAlign()" title="Align Left"
										class="font18 black opacityHover" href=""><img src="/assets/img/left-align.svg" class="svgLeftRightAlign"/></a>
										<a ng-show="alignLeft" ng-click="rightAlign()" title="Align Right"
										class="font18 black opacityHover" href=""><img src="/assets/img/right-align.svg" class="svgLeftRightAlign"/></a>
									
									<a ng-show="flagPanelExpanded" ng-click="reduceFlagPanel()"
										title="Reduce window" class="marginLeft5 font18 black ng-cloak" href=""><i
										class="fa fa-compress"></i></a> <a ng-show="!flagPanelExpanded"
										ng-click="expandFlagPanel()" title="Expand window"
										class="font18 black ng-cloak marginLeft5" href=""><i class="fa fa-expand"></i></a>
									 	
										 
									<a ng-click="closePanelForFlag()" title="Close"
										class="closeFlagButton marginLeft5 font18 black ng-cloak" href=""><i
										class="fa fa-times"></i></a>
								</div>
							</div>
						</div>
						<hr class="headerHR">




						<div class="fakeScreen">
							<div class="row">
								<div class="col-md-6 marginTop5">
									

									<div ng-show="!tmpPanelFlag.flagList[0].optional"
										class="ng-cloak inlineBlock marginLeft5">
										<span
											class="{{getFlagResultStatusClass(tmpPanelFlag.flagList[0])}} status-selfcheck"><span
											class="dot {{getFlagResultStatusClass(tmpPanelFlag.flagList[0])}}-dot"></span>{{getFlagResultStatus(tmpPanelFlag.flagList[0])}}</span>
										
									</div>
									<small class="text-muted"
											ng-show="!tmpPanelFlag.flagList[0].optional && resultsLastRefreshed != undefined"><br/>refreshed
											at
											{{getDateInCurrentTimezone(resultsLastRefreshed,'HH:mm')}}</small>
									<a ng-show="tmpPanelFlag.flagList[0].optional" href=""
										class="marginLeft5 btn disabled btn-xs borderRadius10 btn-info inlineBlock">Optional</a>
								</div>
								<div class="col-md-6">



									<div class="flagStatusButtons">

										<button type="button"
											ng-disabled="isSolved(tmpPanelFlag.flagList[0])"
											ng-show="tmpPanelFlag.flagList[0].hintAvailable"
											ng-click="getHintModal(tmpPanelFlag.flagList[0].id,undefined,tmpPanelFlag.flagList[0].hint.scoreReducePercentage,false)"
											class="btn btn-info" aria-label="Left Align">
											<span class="marginRight5 fa fa-question fa-lg"
												aria-hidden="true"></span>Hint
										</button>
									
									</div>
								</div>
							</div>

							<hr class="exerciseInstructionsHr">
							<p ng-show="!isSolved(tmpPanelFlag.flagList[0])" ng-class="getTerminalMessageClass()" class="line2 marginTop0 marginBottom0 font14">
								{{terminalMessage}}
							</p>
							<p ng-show="tmpPanelFlag.flagList[0].optional && !isHintDisplayed()" class="line2 lblue font14 marginBottom0">
										 This step is optional, click on "Next" to skip without losing points.
									</p>
							<p class="line2 green font14"
								ng-show="isSolved(tmpPanelFlag.flagList[0]) && mdSelfCheckNotShown()">
								Congratulations, you have completed this flag!</p>
							<div class="{{markdownClass}}" id="selfCheckMarkdown-md"></div>
							<div id="hintMarkdown-md"></div>
						</div>
						<button ng-click="skipFinishAction(tmpPanelFlag)"
							ng-show="tmpPanelFlag.flagList[0].optional || isSolved(tmpPanelFlag.flagList[0])"
							class="btn btn-primary btn-block marginTop5">{{
							tmpPanelFlag.flagList[0].type == 'REMEDIATION' && "Finish" ||
							"Next"}}</button>
						<button ng-show="!tmpPanelFlag.flagList[0].optional && tmpPanelFlag.flagList[0].selfCheckAvailable && !isSolved(tmpPanelFlag.flagList[0])"
											ng-click="refreshResults(tmpPanelFlag.flagList[0].selfCheck.name)"
											ng-disabled="terminalMessage == 'Checking your results...'"
											type="button" class="btn btn-success btn-block">
											<span class="marginRight5 fa fa-check-square-o fa-lg"></span>Test
										</button>
					</div>

					<div class="lower">


						<div class="ng-cloak">
							<hr class="exerciseInstructionsHr" />

							<div class="instructionsPlaceholder"></div>
							<div class="instructionsWizard"
								id="fq-{{tmpPanelFlag.flagList[0].id}}-md"></div>
						</div>
					</div>
				</div>

			</div>


			<div id="sfexercise" ng-class="{'blurFilter' : sideBarOpen }">
				<div ng-show="!mobile">
					<div id="display"></div>
				</div>
				<div class="frame100" ng-show="mobile">


					<div id="mobileDisplay"></div>
					<div id="mobileEmulator">
						<div class="emulatorPreload" ng-show="emulatorPreload">
							<p class="lead">
								Please wait for Android Studio to load. <br />
							</p>
							<img src="/assets/img/android.png">
							<p class="lead">
								Your Android device <br /> will be ready in:
							</p>
							<p class="lead bold inlineBlock" id="cdownEmulator"></p>
						</div>
					</div>

				</div>
			</div>
			<div id="exerciseTimeoutModal" class="modal fade top30" tabindex="-1"
				role="dialog">
				<div class="modal-dialog modal-lg" role="document">
					<div class="modal-content">
						<div class="modal-header">

							<h4 class="modal-title">SecureFlag</h4>
						</div>
						<div class="modal-body">
							<div class="outouftime">
								<img src="/assets/img/hourglass.png">
								<p class="lead">You're out of time. This exercise has ended.</p>
							</div>
						</div>
						<div class="modal-footer">
							<button type="button" class="btn btn-primary"
								ng-click="backToCompleted()">Back to Portal</button>
						</div>
					</div>
				</div>
			</div>

			<div id="exerciseStatusModal" class="modal top3P" tabindex="-1"
				role="dialog">
				<div class="modal-dialog" role="document">
					<div class="modal-content">
						<div class="modal-header">

							<h4 class="modal-title">Stop Exercise - {{exerciseDetails.title}} ({{exerciseDetails.technology}})</h4>
						</div>
						<div class="modal-body statusModalBody">

							<div class="center" ng-show="status">
								<p class="font16">Exercise Status: <strong class="green marginTop20"
										ng-show="scoredFlags.length == solvedFlags">Completed</strong>
								<strong class="red" ng-show="scoredFlags.length != solvedFlags">Not solved</strong></p>
								<p class="font16 marginTop0">Points: <strong>{{exerciseScore}}</strong></p>
							
								<div class="div100 marginTop20">
									<table class="flagListStatus table table-hover" id="exitExerciseResultsTable" ng-show="scoredFlags.length>0">
										<thead>
											
										</thead>
										<tbody>
											<tr>
												<td><strong>Start</strong></td>
												<td></td>
												<td><button ng-show="hackUnlocked"  disabled="disabled" class="btn btn-success">Completed</button> <button ng-show="!hackUnlocked"  disabled="disabled" class="btn btn-danger">Not Completed</button></td>
											</tr>
											<tr>
												<td><strong>Hack</strong></td>
												<td>{{getUsedHintInfo("EXPLOITATION")}}</td>
												<td><button class="btn btn-info">Optional</button></td>
											</tr>
											<tr>
												<td><strong>Fix</strong></td>
												<td>{{getUsedHintInfo("REMEDIATION")}}</td>
												<td><button ng-show="getFlagCompleted('REMEDIATION')  != 0" disabled="disabled" class="btn btn-success">Completed <small>({{getFlagCompleted('REMEDIATION')}} points)</small></button> <button ng-show="getFlagCompleted('REMEDIATION')  == 0"  disabled="disabled" class="btn btn-danger">Not Completed</button></td>
											</tr>

										</tbody>
									</table>
								</div>
								<div class="marginTop30">
									<p class="lead marginBottom0">Do you want to stop this exercise?</p>
								</div>
							</div>
							<div ng-show="stars" class="center card height250">
								<p class="lead mTop14PC">How was this exercise?</p>
								<fieldset class="rating">
									<input ng-model="currentVote" ng-change="voteExercise()"
										type="radio" id="star5" name="rating" value="5" /> <label
										for="star5" class="full" title="Excellent"></label> <input
										ng-model="currentVote" ng-change="voteExercise()" type="radio"
										id="star4" name="rating" value="4" /> <label for="star4"
										class="full" title="Good"></label> <input
										ng-model="currentVote" ng-change="voteExercise()" type="radio"
										id="star3" name="rating" value="3" /> <label for="star3"
										class="full" title="Average"></label> <input
										ng-model="currentVote" ng-change="voteExercise()" type="radio"
										id="star2" name="rating" value="2" /> <label for="star2"
										class="full" title="Bad"></label> <input type="radio"
										ng-model="currentVote" ng-change="voteExercise()" id="star1"
										name="rate" value="1" /> <label for="star1" class="full"
										title="Poor"></label>
								</fieldset>
							</div>
							<div ng-show="feedback" class="center card height250 feedback">
								<p class="lead mTop11PC">What could be improved?</p>
								<textarea ng-model="feedbackText" rows="3"
									class="feedbackTextarea fInput"></textarea>
								<a ng-click="sendFeedback()"
									class="btn btn-success outline marginTop10">Send</a>
							</div>
							<div ng-show="thanks" class="center card height250 ">
								<p class="lead mTop21PC">Thank you for your feedback!</p>
							</div>
						</div>
						<div class="modal-footer">
							<div ng-show="status">

								<button type="button" class="btn btn-warning"
									id="doStopExerciseButton"
									ng-show="scoredFlags.length != solvedFlags"
									ng-click="stopExercise()">Stop Exercise</button>
								<button type="button" class="btn btn-success"
									ng-show="scoredFlags.length == solvedFlags"
									ng-click="stopExercise()">Stop Exercise</button>
								<button type="button" class="btn btn-default"
									data-dismiss="modal">Cancel</button>
							</div>
							<div ng-show="!status && !thanks">
								<button id="skipFeedback" type="button" class="btn btn-default"
									ng-click="closeFeedbackSteps(300);">Skip</button>
							</div>
						</div>
					</div>
				</div>
			</div>

			<div id="kbStackModal" ng-show="startOpen" ng-class="getStackKBSizeAndOrientation()" class="modal">
				<div class="modal-dialog modal-lg" role="document">
					<div class="modal-content"
						ng-class="{'largeStackKBPanel' : stackKBExpanded}">
						<div class="modal-body paddingTop0">


							<div class="upper">
								<div class="row">
									<div class="col-md-8">
										<img class="flIcon hackFixIcon hackIconFlag startIconM"
											src="/assets/img/start.svg">
										<div class="liTitle">
											<h4 class="modal-title inlineBlock ">{{tmpKBStackTitle}}</h4>
										</div>

									</div>

									<div class="col-md-4">
										<div class="floatRight marginTopM5 ng-cloak menuOpacity">
										<a ng-show="!alignLeft" ng-click="leftAlign()" title="Align Left"
										class="font18 black opacityHover" href=""><img src="/assets/img/left-align.svg" class="svgLeftRightAlign"/></a>
										<a ng-show="alignLeft" ng-click="rightAlign()" title="Align Right"
										class="font18 black opacityHover" href=""><img src="/assets/img/right-align.svg" class="svgLeftRightAlign"/></a>
									
											<a ng-show="stackKBExpanded" ng-click="reduceStackKB()"
												title="Reduce window" class="font18 black ng-cloak marginLeft5" href=""><i
												class="fa fa-compress"></i></a> <a ng-show="!stackKBExpanded"
												ng-click="expandStackKB()" title="Expand window"
												class="font18 black ng-cloak marginLeft5" href=""><i class="fa fa-expand"></i></a> <a
												ng-click="closeStackKB()" title="Close"
												class="closeFlagButton marginLeft5 font18 black ng-cloak" href=""><i
												class="fa fa-times"></i></a>
										</div>
									</div>
								</div>
								<hr class="headerHR">




								<div class="fakeScreen">
									<div class="row">
										<div class="col-md-8 marginTop5">
											

											<div ng-show="!tmpPanelFlag.flagList[0].optional"
												class="ng-cloak inlineBlock marginLeft5">
												<span
													ng-class="getAppStatusClass()"
													class="status-selfcheck"><span class="dot"
													ng-class="getAppStatusClass()+'-dot'"></span>{{appStatusText}}</span>
											</div>
											<a ng-show="tmpPanelFlag.flagList[0].optional" href=""
												class="marginLeft5 btn disabled btn-xs borderRadius10 btn-info inlineBlock">Optional</a>
										</div>
										<div class="col-md-4">



											<div class="flagStatusButtons">
												
											</div>
										</div>

									</div>
									<hr class="exerciseInstructionsHr">


									<div ng-show="appStatusRunning">
										<p class="green font14 line2">
											The exercise has started correctly, please
												click on "Next".
										</p>
									</div>
									<div ng-show="!appStatusRunning && !appStatusTested">
										<p class="font14 line2">
											Follow the instructions to start the application, then click on "Test".
										</p>
									</div>
									<div ng-show="!appStatusRunning && appStatusTested">
										<p class="red font14 line2">
											The application is not running. Follow the instructions below, then click on "Test".
										</p>
									</div>

								</div>
								<button ng-click="goToHack()" ng-show="appStatusRunning"
									class="btn btn-primary btn-block marginTop5">Next</button>
								<button ng-show="!appStatusRunning" ng-disabled="appStatusText == 'Updating...' || emulatorPreload" ng-click="refreshAppStatus()" type="button" class="btn btn-block btn-success">
													<span class="marginRight5 fa fa-check-square-o fa-lg"></span>Test
												</button>
							</div>

							<div id="kbStackMD"></div>

						</div>


					</div>
				</div>
			</div>
			<div id="kbModal" ng-show="learnOpen" ng-class="getKBSizeAndOrientation()" class="modal"
				tabindex="-1" role="dialog">
				<div class="modal-dialog modal-lg" role="document"
					ng-class="{'largeKBPanel' : kbExpanded}">
					<div class="modal-content" ng-class="{'largeKBPanel' : kbExpanded}">



						<div class="modal-body paddingTop0" ng-class="{'modalBodyPaddingRight30' : kbExpanded}">
							<div class="row">
								<div class="col-md-8">
									<img class="flIcon hackFixIcon hackIconFlag startIconM"
										src="/assets/img/start.svg">
									<div class="liTitle">
										<h4 class="modal-title inlineBlock ">{{tmpKBTitle}}</h4>
									</div>

								</div>

								<div class="col-md-4 ng-cloak">
									<div class="floatRight marginTopM5 ng-cloak menuOpacity">
									<a ng-show="!kbAlignLeft" ng-click="leftKBAlign()" title="Align Left"
										class="font18 black opacityHover" href=""><img src="/assets/img/left-align.svg" class="svgLeftRightAlign"/></a>
										<a ng-show=kbAlignLeft ng-click="rightKBAlign()" title="Align Right"
										class="font18 black opacityHover" href=""><img src="/assets/img/right-align.svg" class="svgLeftRightAlign"/></a>
									
										<a ng-show="kbExpanded" ng-click="reduceKB()"
											title="Reduce window" class="ng-cloak font18 black marginLeft5" href=""><i
											class="fa fa-compress"></i></a> <a ng-show="!kbExpanded"
											ng-click="expandKB()" title="Expand window" class="ng-cloak font18 black marginLeft5"
											href=""><i class="fa fa-expand"></i></a> <a
											ng-click="closeKB()" title="Close"
											class="closeFlagButton font18 black ng-cloak marginLeft5" href=""><i
											class="fa fa-times"></i></a>
									</div>
								</div>
							</div>
							<hr class="headerHR">
							<div id="kbMD"></div>
						</div>
					</div>
				</div>
			</div>
			<div id="getHintModal" class="modal" tabindex="-1" role="dialog">
				<div class="modal-dialog" role="document">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal"
								aria-label="Close">
								<span aria-hidden="true">&times;</span>
							</button>
							<h4 class="modal-title">Hint</h4>
						</div>
						<div class="modal-body">
							<p class="lead">
								This hint has an impact of <strong>{{hintFlagReductionPoints}} points</strong> ({{hintFlagReduction}}%)
								on the final score.
							</p>
						</div>
						<div class="modal-footer">
							<button type="button" class="btn btn-default"
								data-dismiss="modal">Close</button>
							<button type="button" ng-click="getHint()"
								class="btn btn-primary">Get Hint</button>
						</div>
					</div>
				</div>
			</div>
			<div id="restoreCodeModal" class="modal" tabindex="-1"
				role="dialog">
				<div class="modal-dialog" role="document">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal"
								aria-label="Close">
								<span aria-hidden="true">&times;</span>
							</button>
							<h4 class="modal-title">Restore Code</h4>
						</div>
						<div class="modal-body">
							<p class="lead">Would you like to restore the exercise's code to its initial state?</p>
						</div>
						<div class="modal-footer">
							<button data-dismiss="modal" class="btn btn-default">Cancel</button>
							<button type="button" ng-click="restoreCode()"
								class="btn btn-danger">Restore</button>
						</div>
					</div>
				</div>
			</div>
			<div id="conectionLostModal" class="modal" tabindex="-1"
				role="dialog">
				<div class="modal-dialog" role="document">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal"
								aria-label="Close">
								<span aria-hidden="true">&times;</span>
							</button>
							<h4 class="modal-title">Connection Lost</h4>
						</div>
						<div class="modal-body">
							<p class="lead">Connection to the exercise has been lost.</p>
						</div>
						<div class="modal-footer">
							<a href="/user/index.html#running" class="btn btn-default">Back
								to Portal</a>
							<button type="button" ng-click="reloadWindow()"
								class="btn btn-primary">Reload</button>
						</div>
					</div>
				</div>
			</div>
			

		<iframe id="cIframe" ng-onload="iframeLoaded(loc)" ng-src="{{cIframeUrl | trustUrl}}"></iframe>

		</div>

	</div>
<div class="waitLoader">
	
		</div>
		
			<script src="/assets/js/libu.min.js"></script>
	<script src="/assets/js/jquery-ui.min.js"></script>
	<script src="/assets/js/all.min.js"></script>

	<script src="/user/js/exercise.js"></script>
</body>
</html>